
#include "PoshParty.h"
#include <stdio.h>
#include <malloc.h>

// Party* Posh_Party::posh_party_factory( const char * name )
Party* Posh_Party::posh_party_factory( const char * name )
{
    printf( "Posh Party factory is running.\n" );
    return new Posh_Party( name );
}

Posh_Party::Posh_Party( const char * name )
    : _count( 0 )
    , _name( 0 )
{
}

Posh_Party::~Posh_Party()
{
    if( _name != 0 ) {
	free( _name );
	_name = 0;
    }
}

void Posh_Party::enter() {
    _count++;
}

void Posh_Party::exit() {
    _count--;
}

int Posh_Party::party( int a, int b ) {
    return a*b + _count;
}

